from funittest import interpreter
from funittest import physical
from funittest import models
from funittest.seleniumrc import DEFAULTTIMEOUT

class Session(models.Physical):
    """
    Clouseau session.
    """
    
    def access(self):
        """
        """
        physical.plone.navigation.open("/clouseau_view")

    def show(self): 
        """
        """
        interpreter.click("//a[@href[contains(.,'showClouseau')]]")
        interpreter.wait_for_condition("selenium.isElementPresent('input-field');",DEFAULTTIMEOUT)    

    def hide(self): 
        """
        """
        interpreter.click("//a[@href[contains(.,'showClouseau')]]")
        
    def process_code(self, code):
        """
        """
        if code['code'].strip():
            for line in code['code'].split('\n'):
                interpreter.wait_for_condition("selenium.isElementPresent('input-field');",DEFAULTTIMEOUT)    
                interpreter.type("input-field", line.strip())
                interpreter.key_down("input-field", "13")
                interpreter.key_up("input-field", "13")
