from funittest import physical
from funittest import interpreter
from funittest import models
from funittest import verify

class Fields(models.Logical):
    """Function to work on KSS fields in Plone.
    """

    @verify
    def select(self, field):
        interpreter.annotate("Select KSS field")
        physical.kss.fields.select(field)
        physical.kss.fields.waitForm(field)

    @verify
    def fill(self, field, content):
        interpreter.annotate("Fill a field")
        physical.kss.fields.fill(field, content)
                
    @verify
    def cancel(self, field, content):
        interpreter.annotate("Press Cancel button")
        physical.kss.fields.pressButton(field, content, "Cancel")
        
    @verify
    def validate(self, field, content):
        interpreter.annotate("Press Save button")
        physical.kss.fields.pressButton(field, content, "Save")

    @verify
    def validateWithKey(self, field, content):
        interpreter.annotate("Press enter in the field")
        physical.kss.fields.pressKey(field, content)
