from funittest import physical
from funittest import interpreter
from funittest import models

class Fields(models.ExpectedStateGenerator):

    def snapshot(self):
        pass

    def cancel(self, field, content):
        value = content[field['id']]
        if value:
            interpreter.verifyTextPresent(value)

    def validate(self, field, content):
        value = content[field['id']]
        if field['required'] and not value:
            interpreter.verifyTextPresent('%s is required, please correct.' % field['at_name'])
        else:
            interpreter.verifyTextNotPresent('%s is required, please correct.' % field['at_name'])
            if value:
                interpreter.verifyTextPresent(value)
            
    def validateWithKey(self, field, content):
        self.validate(field, content)
