from funittest import logical
from funittest import dataprovider
from funittest import physical
from funittest import interpreter
from funittest import scenarios
from funittest import Schema
from funittest import models

class TranslateContent(models.Test):
    """
    Test that content can be translated to another language
    """
    schema = Schema()
    
    def setUp(self):
        admin = dataprovider.plone.user.get("admin")
        scenarios.plone.login(user=admin)
        logical.plone.navigation.top()

        # Add french as additional available language:
        #physical.plonelanguagetool.configlet.configure_supported_languages(['en', 'fr'])

        # Create an english content object in a folder:
        folder = {'id':'folder','title':'Folder','type_name':'Folder'}
        content = {'id':'doc','title':'Doc','type_name':'Document'}
        self._path = {'id':'english_doc_in_folder','path':[folder, content]}
        scenarios.plone.nestcontent(path=self._path)

        # Switch to english language
        physical.plonelanguagetool.language.switch_language('en')

    def step_1(self):
        # Translate the english document to french
        physical.linguaplone.content.translate(self._path, 'en', 'fr')

    def test(self):
        self.expect_ok(1)
