import urllib

from funittest import interpreter
from funittest import physical
from funittest import models
from funittest.lib.plone.newest.physical.pom_folder import Folder as NewestFolder

class Folder(NewestFolder):
    _add_locator = "//dl[@id='objectMenu']//li[@class[contains(.,'contenttype-%s')]]//a"
    _factory_locator = "objectMenu"

    def is_addable(self, content):
        if interpreter.is_element_present(self._add_locator % content['type_name'].lower().replace(" ","-")):
            # For "News Item", we need to put in a "-" instead of the space
            return True
        elif interpreter.is_element_present("//a[@href[contains(.,'createObject?type_name=%s')" % content['type_name']):
            return True
        else:
            return False

    def addable_type_names(self):
        if interpreter.is_element_present(self._factory_locator):
            hrefs = physical.plone.utils.getHrefs(self._factory_locator)
        else:
            hrefs = physical.plone.utils.getHrefs("//div[@class[contains(.,'contentActions')]]")
        addable = []
        for link in hrefs:
            if "createObject?type_name=" in link:
                type_name = link.split("createObject?type_name=")[-1]
                # For "News Item" we get "News%20Item", so we need to unquote
                addable.append(urllib.unquote(type_name))
        return addable
        
    def add_using_dropdown(self, content):
        # For "News Item", we need to put in a "-" instead of the space
        if interpreter.is_element_present(self._add_locator % content['type_name'].lower().replace(" ","-")):
            interpreter.clickAndWait(self._add_locator % content['type_name'].lower().replace(" ","-"))
        else:
            interpreter.clickAndWait("//a[@href[contains(.,'createObject?type_name=%s')]]" % content['type_name'])
