from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SetPortalSettings(models.Scenario):
    """
    Set portal settings
    
    Main scenario
    
    1. Go to portal settings
    2. Configure settings
    3. Save
    """

    schema = Schema({"portalsettings":dataprovider.plone.portalsettings})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.portalsettings.access()

    def step_2(self):
        logical.plone.portalsettings.edit(self._portalsettings)

    def step_3(self):
        logical.plone.portalsettings.submit()

    def scenario(self):
        """
        Set site portal settings
        """
        self.expect_ok(1,2,3)
    
    def scenario_3a(self):
        """
        Setting wrong configuration.
        """
        portalsettings = self._portalsettings.copy()
        for key in self._portalsettings:
            if self._portalsettings[key]:
                self._portalsettings[key]=False
            else:
                self._portalsettings[key]=True
        self.expect_ko(1,2,3)
        self._portalsettings = portalsettings
        self.expect_ok(2,3)

