from funittest import interpreter
from funittest import physical
from funittest import models

class Register(models.Physical):
    def access(self, user):
        physical.plone.navigation.open('/join_form')
    
    def fill(self, user):
        forms = physical.plone.forms.getForms()
        form = forms.getFormByLocator("//form[@action='join_form']")
        values = []
        values.append( {'id':'fullname', 
                        'value':user['fullname']} )
        values.append( {'id':'username',
                        'value':user['username']} )
        values.append( {'id':'email',
                        'value':user['email']} )
        values.append( {'id':'password',
                        'value':user['password']} )
        values.append( {'id':'password_confirm',
                        'value':user['password_confirm']} )
        form.fillForm(values)

    def submit(self, user):
        interpreter.clickAndWait("form.button.Register")

    def direct_login(self, user):
        interpreter.annotate("Login after registration")
        interpreter.clickAndWait("//input[@value='Log in']")

