# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import models
from funittest import scenarios

class Group(models.DataProvider):
    def establish(self, keys):
        for key in keys:
            group = self.get(key)
            if scenarios.plone.searchgroup.try_scenario(group=group):
                pass # Group found, so no need to add it
            else:
                scenarios.plone.addgroup(group=group)
            scenarios.plone.setgroupprops(group=group)
            scenarios.plone.setgrouproles(group=group)
    
defaults = {'id': 'GroupName',
            'title': 'GroupTitle',
            'description':'',
            'email':'',
            'roles':[],}
key='id'
group = Group("Plone", defaults, key)
provide = group.provide
provide({'id':'Administrators',
         'title':'Administrators',
         'roles':['Manager']
        })
provide({'id':'Reviewers',
         'title':'Reviewers',
         'roles':['Reviewer']
        })
