from funittest import models
from funittest import scenarios

class Path(models.DataProvider):
    def establish(self, keys):
        for key in keys:
            scenarios.plone.nestcontentmerge(path=self.get(key))

defaults = {'id': 'emptypath',
            'path':[],
            }
key='id'
path = Path("Plone", defaults, key)
provide = path.provide

testfolder = {'id':'test-folder', 
              'title':'Test Folder',
              'description':'Test Folder description',
              'type_name':'Folder'}
folder2 = {'id':'folder-2', 
           'title':'Folder 2',
           'description':'Folder 2 description',
           'type_name':'Folder'}
document3 = {'id':'document-3', 
             'title':'Document 3',
             'description':'Document 3 description',
             'text':'Document 3 text',
             'type_name':'Document'}
document4 = {'id':'document-4',
             'title':'Document 4',
             'description':'Document 4 description',
             'text':'Document 4 text',
             'type_name':'Document'}

provide({'id':'descending_path_1',
         'path':[testfolder, folder2, document3]
        }
       )
provide({'id':'descending_path_2',
         'path':[testfolder, folder2, document4]
        }
       )
provide({'id':'descending_path_3',
         'path':[testfolder, folder2]
        }
       )
provide({'id':'events',
         'path':[{'id':'events',
                  'title':'Events',
                  'type_name':'Topic',
                  'description':''
                  },]
        }
       )
provide({'id':'news',
         'path':[{'id':'news',
                  'title':'News',
                  'type_name':'News+Item',
                  'description':''
                  },]
        }
       )
provide({'id':'users',
         'path':[{'id':'Members', 
                  'title':'Users',
                  'type_name':'Folder',
                  'description':''},]
        }
       )
provide({'id':'/',
         'path':[]
        }
       )
provide({'id':'page_in_two_folders',
         'path':[{'id':'projects',
                  'title':'Projects',
                  'type_name':'Folder',
                  'description':''
                 },
                 {'id':'television',
                  'title':'Television',
                  'type_name':'Folder',
                  'description':''
                 },
                 {'id':'page-1',
                  'title':'Page 1',
                  'type_name':'Document',
                  'description':''
                 },
                ]
        }
        )
