# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import models
from funittest import scenarios

class SiteSecurity(models.DataProvider):
    """Security Control Panel"""

    def filtered(self, key):
        pass
    
    def any(self, key):
        pass

    def establish(self, key):
        scenarios.plone.setsitesecurity(sitesecurity=self.get(key))

defaults = {'title':'Security Control Panel',
            'enable_self_reg':False,
            'enable_user_pwd_choice':False,
            'enable_user_folders':False,
            'allow_anon_views_about':False,
           }

key='title'
sitesecurity = SiteSecurity("Plone", defaults, key)
provide = sitesecurity.provide

provide({'title':'No self registration',
         'enable_self_reg':False,
         'enable_user_pwd_choice':False,
         'enable_user_folders':False,
         'allow_anon_views_about':False,
        })

provide({'title':'Self registration with password choice',
         'enable_self_reg':True,
         'enable_user_pwd_choice':True,
         'enable_user_folders':False,
         'allow_anon_views_about':False,
        })
