# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import scenarios
from funittest import models

class TypeSetting(models.DataProvider):
    def establish(self, keys):
        for key in keys:
            typesetting = self.get(key)
            scenarios.plone.settypesetting(typesetting=typesetting)

defaults = {'id':'Type',
            'type_id':'Type',
            'addable':True,
            'allow_discussion':False,
            'versionable':False,
            'searchable':True,
            'new_workflow':'(Default)',
            }
key='id'
typesetting = TypeSetting("Plone", defaults, key)
provide = typesetting.provide

provide({'id':'Topic',
         'type_id':'Topic'})
provide({'id':'Event',
         'type_id':'Event',
         'versionable':True})
provide({'id':'Favorite',
         'type_id':'Favorite'})
provide({'id':'File',
         'type_id':'File',
         'new_workflow':'[none]'})
provide({'id':'Folder',
         'type_id':'Folder'})
provide({'id':'Image',
         'type_id':'Image',
         'new_workflow':'[none]'})
provide({'id':'Large Plone Folder',
         'type_id':'Large Plone Folder',
         'addable':False,})
provide({'id':'Link',
         'type_id':'Link',
         'versionable':True})
provide({'id':'News Item',
         'type_id':'News Item',
         'versionable':True})
provide({'id':'Document',
         'type_id':'Document',
         'versionable':True})
provide({'id':'onestateworkflowfolder',
         'type_id':'Folder',
         'new_workflow':'one_state_workflow'})
provide({'id':'onestateworkflowdocument',
         'type_id':'Document',
         'versionable':True,
         'new_workflow':'one_state_workflow'})
