from funittest import interpreter
from funittest import scenarios
from funittest import models

class User(models.DataProvider):

    _form = ['fullname', 'email', 'visible_ids']

    def establish(self, keys):
        for key in keys:
            user = self.get(key)
            if key == "admin" or key == "anon":
                pass
            else:
                if scenarios.plone.searchuser.try_scenario(user=user):
                    pass # User found, so don't need to add the user
                else:
                    scenarios.plone.adduser(user=user)
 
                # Prepare the form that needs to be filled in from the fields
                # selected for the test, using the user info available
                form = {}
                for key in self._form:
                    form[key] = user[key]
                scenarios.plone.setuserprops(user=user, form=form)
                scenarios.plone.setuserroles(user=user)

defaults = {'id': 'user',
            'username':'sampleuser',
            'fullname':'Sample User',
            'password':'seleniumtest',
            'password_confirm':'seleniumtest',
            'email':'test@example.com',
            'visible_ids':True,
            'roles':['Member'],
            'groups':[],}
key='id'
user = User("Plone", defaults, key)
provide = user.provide
provide({'id':'anon',
         'username':None,
         'fullname':None,
         'password':None,
         'roles':[],
         'groups':[],})
provide({'id':'admin',
         'username':'admin',
         'fullname':'admin',
         'password':'admin',
         'roles':['Manager',],
         'groups':[],})

## /Plone/portal_skins/plone_scripts/getGlobalPortalRoles
## return [r for r in context.portal_membership.getPortalRoles() if r != 'Owner']
#provide({'id':'owner',
#         'username':'owner',
#         'fullname':'Sample Owner',
#         'roles':['Member','Owner'],
#         'groups':[],})
provide({'id':'manager',
         'username':'samplemanager',
         'fullname':'Sample Manager',
         'roles':['Member','Manager'],
         'groups':['Administrators']})
provide({'id':'managerreviewer',
         'username':'samplemanagerreviewer',
         'fullname':'Sample Manager Reviewer',
         'roles':['Member','Manager','Reviewer'],
         'groups':['Administrators', 'Reviewers',]})
provide({'id':'member',
         'username':'samplemember',
         'fullname':'Sample Member',
         'roles':['Member',]})
provide({'id':'reviewer',
         'username':'samplereviewer',
         'fullname':'Sample Reviewer',
         'roles':['Member','Reviewer'],
         'groups':['Reviewers'],})
provide({'id':'contributor',
         'username':'samplecontributor',
         'fullname':'Sample Contributor',
         'roles':['Member','Contributor'],})
provide({'id':'editor',
         'username':'sampleeditor',
         'fullname':'Sample Editor',
         'roles':['Member','Editor'],})
provide({'id':'reader',
         'username':'samplereader',
         'fullname':'Sample Reader',
         'roles':['Member','Reader'],})
