from funittest import physical
from funittest import logical
from funittest import dataprovider
from funittest import models
from funittest import verify

class Product(models.Logical):

    def installed_products(self):
        return physical.plone.product.installed_products()
        
    def uninstalled_products(self):
        return physical.plone.product.uninstalled_products()

    @verify
    def access(self):
        configlet = dataprovider.plone.configlet.get("Add-ons")
        logical.plone.configlet.access(configlet)

    @verify
    def select(self, product):
        physical.plone.product.select(product)

    @verify
    def install(self, product):
        physical.plone.product.install(product)

    @verify
    def uninstall(self, product):
        physical.plone.product.uninstall(product)

