from funittest import interpreter
from funittest import models
from funittest import physical
from funittest import verify

class Search(models.Logical):

    def access_advanced_search_using_url(self):
        physical.plone.search.access_advanced_search_using_url()

    def access_advanced_search_using_access_key(self):
        physical.plone.search.access_advanced_search_using_access_key()
        
    access_advanced_search_composite_execution_behaviour = [access_advanced_search_using_url, 
                                                            access_advanced_search_using_access_key]
    @verify
    def access_advanced_search(self):
        interpreter.annotate("Access advanced search")

    @verify
    def search_text(self, text):
        """
        Searches for a text.
        """
        physical.plone.search.search(text['text'])
        
    @verify
    def search_content(self, content, postcondition=""):
        """
        Searches for the content using its title.
        
        Postcondition can be "matches:0", "matches:1", ...
        """
        physical.plone.search.search(content['title'])
        if postcondition.startswith("matches"):
            matches = int(postcondition.split(":")[1])
            if matches == 0:
                return physical.plone.search.results_list_is_empty()
            else:            
                return physical.plone.search.results_number_equals(matches)

    @verify
    def browse_results(self, content):
        physical.plone.search.browse_results(content)

    @verify
    def results_number(self):
        if physical.plone.search.results_list_is_empty():
            return 0
        else:
            return physical.plone.search.results_number()
        
    @verify
    def access_content(self, content):
        return physical.plone.search.access_content(content)



