from funittest import physical
from funittest import interpreter
from funittest import models
from funittest import verify

class Workflow(models.Logical):
   
    @verify
    def get_state(self):
        """
        Returns the workflow state of the current content, or None if it can't be found.
        """
        return physical.plone.workflow.get_state()

    @verify
    def change_state(self, transition):
        """
        Changes the workflow state using the transition.
        """
        physical.plone.workflow.change_state(transition['id'])

    @verify
    def access_review_list(self, content):
        physical.plone.workflow.access_review_list(content)
    
    @verify
    def browse_review_list(self, content):
        physical.plone.workflow.browse_review_list(content)
        
    @verify
    def access_content_to_review(self, content):
        physical.plone.workflow.access_content_to_review(content)
