from funittest import interpreter
from funittest import physical
from funittest import models
from funittest.seleniumrc import DEFAULTTIMEOUT

class AddUser(models.Physical):

    def add_user(self, user):
        interpreter.click("form.button.AddUser")
        interpreter.wait_for_condition("selenium.browserbot.getCurrentWindow().jQuery.active == 0", DEFAULTTIMEOUT)
        
    def fill(self, user):
        forms = physical.plone.forms.getForms()
        form = forms.getFormByLocator("//form[@id='zc.page.browser_form']")
        values = []
        values.append( {'id':'form.fullname', 
                        'value':user['fullname']} )
        values.append( {'id':'form.username',
                        'value':user['username']} )
        values.append( {'id':'form.email',
                        'value':user['email']} )
        values.append( {'id':'form.password',
                        'value':user['password']} )
        values.append( {'id':'form.password_ctl',
                        'value':user['password_confirm']} )
        form.fillForm(values)

    def submit(self, user):
        interpreter.click("form.actions.register")
