from funittest import interpreter
from funittest import models
from funittest import physical
from funittest.seleniumrc import DEFAULTTIMEOUT

class FolderContents(models.Physical):

    def has_tab(self):
        physical.plone.tab.has_tab('folderContents')

    def access(self):
        physical.plone.tab.access('folderContents')

    def in_folder_contents(self, content):
        target = "//tr[@id=\'folder-contents-item-%s\']//a" % content['id']
        return interpreter.is_element_present(target)

    def down(self, content):
        target = "//tr[@id=\'folder-contents-item-%s\']//a" % content['id']
        interpreter.clickAndWait(target)
    
    def show_all(self):
        if interpreter.is_element_present('foldercontents-show-all'):
            interpreter.click('foldercontents-show-all')
            target = 'foldercontents-show-batched'
            locator = 'selenium.isElementPresent(\"%s\");' % target 
            interpreter.wait_for_condition(locator, DEFAULTTIMEOUT) 
            
    def select(self, content):
        interpreter.click("//tr[@id='folder-contents-item-%s']/td/input[@id='cb_%s']" % (content['id'], content['id']))

    def delete(self, content):
        interpreter.clickAndWait("//input[@value='Delete']")

