from funittest import physical
from funittest import interpreter
from funittest import models

class Form(models.Physical):
    """
    Forms usually have some common elements, like the save and
    cancel buttons.
    """

    def fill(self, form_name, values):
        forms = physical.plone.forms.getForms()
        form = forms.getForm(form_name)
        form.fillForm(values)
    
    def save(self):
        """
        Save the form.
        """
        interpreter.annotate("Save")
        if interpreter.is_element_present("//form[@name='edit_form']//input[@name='form_submit']"):
            interpreter.clickAndWait("//form[@name='edit_form']//input[@name='form_submit']")
        elif interpreter.is_element_present("//form[@name='edit_form']//input[@name='form.button.Save']"):
            interpreter.clickAndWait("//form[@name='edit_form']//input[@name='form.button.Save']")
        else:
            interpreter.clickAndWait("//form[@name='edit_form']//input[@name='form.button.save']")

    def cancel(self):
        """
        Cancel the form.
        """
        interpreter.annotate("Cancel")
        if interpreter.is_element_present("//form[@name='edit_form']//input[@name='form.button.cancel']"):
            interpreter.clickAndWait("//form[@name='edit_form']//input[@name='form.button.cancel']")
        else:
            interpreter.clickAndWait("//form[@name='edit_form']//input[@name='form.button.Cancel']")

