from funittest import interpreter
from funittest import models

class NavigationTree(models.Physical):
    _target = "//dl[@class[contains(.,'portletNavigationTree')]]//a[@href='%s']"
    _current = "//a[@class[contains(.,'navTreeCurrentItem')]]/@href"

    def current_item(self):
        return interpreter.get_attribute(self._current)

    def has_content(self, context):
        url = interpreter.getBrowserURL()
        if url.endswith("/"):
            target = self._target % (url + context['context'])
        else:
            if context['context'].startswith("/"):
                target = self._target % (url + context['context'])
            else:
                target = self._target % (url + '/' + context['context'])
        return interpreter.is_element_present(target)

    def access(self, context):
        url = interpreter.getBrowserURL()


        if context['context'].startswith("/"):
            target = self._target % (url + context['context'])
        else:
            target = self._target % (url + '/' + context['context'])

        interpreter.clickAndWait(target)

