from funittest import interpreter
from funittest import models

class PortalTab(models.Physical):
    """
    All content types can have tabs, which are always accessed
    in the same way.
    """

    def has_content(self, content):
        return interpreter.is_element_present("//li[@id='portaltab-%s']//a"  % content['id'])

    def access(self, content):
        """
        Access a content in the portal tabs.
        """
        interpreter.annotate("Access the portal tab for the content with id %s" % content['id'])
        interpreter.clickAndWait("//li[@id='portaltab-%s']//a" % content['id'])
