from funittest import interpreter
from funittest import physical
from funittest import models

class Product(models.Physical):
    installed_locator = "//form[@action[contains(.,'portal_quickinstaller')]][2]"
    uninstalled_locator = "//form[@action[contains(.,'portal_quickinstaller')]][1]"

    def installed_products(self):
        if interpreter.is_element_present(self.installed_locator):
            return physical.plone.utils.getAllCheckboxFieldValues(self.installed_locator, "products:list")
        else:
            return []

    def uninstalled_products(self):
        if interpreter.is_element_present(self.uninstalled_locator):
            return physical.plone.utils.getAllCheckboxFieldValues(self.uninstalled_locator, "products:list")
        else:
            return []

    def select(self, product):
        interpreter.click("//input[@value='%s']" % product['id'])

    def install(self, product):
        interpreter.clickAndWait("//input[@value='Install']")

    def uninstall(self, product):
        interpreter.clickAndWait("//input[@value='Uninstall']")

