from funittest import interpreter
from funittest import physical
from funittest import models

class Register(models.Physical):
    def access(self, user):
        physical.plone.navigation.open('/@@register')
    
    def fill(self, user):
        forms = physical.plone.forms.getForms()
        url = interpreter.getBrowserURL()
        target = "//form[@action='%s/@@register']" % url        
        form = forms.getFormByLocator(target)
        values = []
        values.append( {'id':'form.fullname', 
                        'value':user['fullname']} )
        values.append( {'id':'form.username',
                        'value':user['username']} )
        values.append( {'id':'form.email',
                        'value':user['email']} )
        values.append( {'id':'form.password',
                        'value':user['password']} )
        values.append( {'id':'form.password_ctl',
                        'value':user['password_confirm']} )
        form.fillForm(values)

    def submit(self, user):
        interpreter.clickAndWait("form.actions.register")

    def direct_login(self, user):
        interpreter.annotate("Login after registration")
        interpreter.clickAndWait("//input[@value='Log in']")

