from funittest import interpreter
from funittest import models

class Schemata(models.Physical):
    """
    Schemata are usually accessible in the edit tab of a content through
    the form of links like this:

    [ default ] [ images ] ...
    
    They allow the user to access the different forms of a content type.
    
    Schemata are also accessible through buttons at the bottom of 
    the form:
    
    [Next] [Previous]
    
    So, there are different ways of accessing a schema.
    
    1. Directly through the links
    
    2. By navigating using the buttons
    """

    at_locator = "link=[%s]"
    plone3_locator = "document.edit_form.elements[0]"

    def access(self, schemata="default"):
        """
        Access the schemata
        
        schemata: Name of the schemata, like "default" or "metadata".
        """
        interpreter.annotate("Access the '%s' schemata" % schemata)
        # XXX Identify existing schematas
        # XXX If already in correct fieldset, do nothing
        if interpreter.is_element_present(self.at_locator):
            interpreter.clickAndWait(self.at_locator % schemata)        
        else:
            interpreter.select(self.plone3_locator, "label=%s" % schemata.capitalize())        
        
