from funittest import interpreter
from funittest import models
from funittest import physical

class Search(models.Physical):

    def access_advanced_search_using_url(self):
        physical.plone.navigation.open('/search_form')

    def access_advanced_search_using_access_key(self):
        interpreter.clickAndWait('//a[@accesskey="1"]')
        
    def search(self, text):
        """
        Searches for a text.
        """
        interpreter.annotate("Search \"" + text + "\"")
        interpreter.type("SearchableText",text)
        interpreter.clickAndWait("//input[@value='Search']")
        
    def browse_results(self, content):
        while not interpreter.is_element_present("link=%s" % content['title']) and interpreter.is_element_present("//span[@class='next']//a"):
            interpreter.clickAndWait("//span[@class='next']//a")

    def results_number(self):
        text = interpreter.get_text("//h1[@class='documentFirstHeading']/span[@class='discreet']/span")
        if len(text) > 0:
            return int(text.split(" ")[0])
        else:
            return 0

    def results_list_is_empty(self):
        return interpreter.is_text_present("No results were found.")

    def results_number_equals(self, number):
        return interpreter.is_text_present("%d items matching your criteria" % number)
        
    def access_content(self, content):
        interpreter.clickAndWait("link=%s" % content['title'])

