from funittest import interpreter
from funittest import models
from funittest.seleniumrc import DEFAULTTIMEOUT 

class Sharing(models.Physical):

    def access(self):
        interpreter.clickAndWait("""link=Sharing""")

    def add_roles_for_user(self, roles_and_username):
        interpreter.clickAndWait("""//input[@value='Perform Search']""")
        interpreter.click("""//input[@name='member_ids:list' and @value='%s']""" % roles_and_username['username'])
        for role in roles_and_username[roles_and_username['roles']]:
            interpreter.select("""user_member_role""","""label=%s"""%roles_and_username['roles'])
        interpreter.clickAndWait("""//input[@value='Assign Local Role to Selected User(s)']""")
        interpreter.verifyTextPresent('changed.')

    def add_roles_for_group(self, groupid_and_roles):
        # If the search for groups is active, we'll first have to search for the group
        if interpreter.is_element_present("group_search_term"):
            interpreter.type("group_search_term",groupid_and_roles['groupid'])
            interpreter.key_press("group_search_term", "13")
            interpreter.wait_for_page_to_load(DEFAULTTIMEOUT)
        if interpreter.is_element_present("group_"+groupid_and_roles['groupid']):
            interpreter.click("group_"+groupid_and_roles['groupid'])
        else:
            interpreter.click("//input[@id='%s']" % groupid_and_roles['groupid'])
        for role in groupid_and_roles['roles']:
            interpreter.select("""group_member_role""","""value=%s"""%role)
        interpreter.clickAndWait("""//input[@value='Assign Local Role to Selected Group(s)']""")
        interpreter.verifyTextPresent('changed.')
