from funittest import interpreter
from funittest import physical
from funittest import models

class Tab(models.Physical):
    """
    All content types can have tabs, which are always accessed
    in the same way.
    """

    def has_tab(self, tab):
        return interpreter.is_element_present("//ul[@class='contentViews']/li[@id='contentview-%s']/a" % tab)

    def access(self, tab):
        """
        Access a specific tab.
        """
        interpreter.annotate("Access the %s tab" % tab)
        if tab=="folderContents":
            if not physical.plone.tab.has_tab(tab):
                physical.plone.navigation.open("/folder_contents")
                return
        interpreter.clickAndWait("//ul[@class='contentViews']/li[@id='contentview-%s']/a" % tab)
