from funittest import interpreter
from funittest import dataprovider
from funittest import physical
from funittest import models
from funittest.seleniumrc import DEFAULTTIMEOUT 

class TypeSetting(models.Physical):

    def edit(self, typesetting):
        physical.plone.navigation.open("/Plone/@@types-controlpanel")
        
        forms = physical.plone.forms.getForms()
        form = forms.getFormByLocator("//form[@action[contains(.,'@@types-controlpanel')]]")
        values = [{"id":'type_id',
                   "value":typesetting['type_id'],
                  },]
        form.fillForm(values)

        interpreter.wait_for_page_to_load(DEFAULTTIMEOUT)
        
        values = []
        for key, value in typesetting.items():
            if key in ["addable","allow_discussion"]:
                values.append( {'id':key + ':boolean',
                                'value':value} )
            if key in ["versionable","searchable"]:
                values.append( {'id':key, 
                                'value':value} )
        form.fillForm(values)
        
        current_workflow = interpreter.get_selected_value("//form[@action[contains(.,'@@types-controlpanel')]]//select[@name='new_workflow']")
        if current_workflow != typesetting['new_workflow']:
            values = [{"id":'new_workflow',
                       "value":typesetting['new_workflow'],
                      },]
            form.fillForm(values)
            interpreter.wait_for_page_to_load(DEFAULTTIMEOUT)

    def submit(self):
        interpreter.clickAndWait("form.button.Save")

