from funittest import models
from funittest import interpreter
from funittest import physical

class UserRoles(models.Physical):

    def get_user_roles(self):
        ctrl = "//form[@name='users_search']"
        name="users.roles:list:records"
        return physical.plone.utils.getAllSelectedCheckboxFieldValues(ctrl, name)

    def set_roles(self, current_roles, new_roles):
        ctrl = "//input[@value='%s']"
        # First remove all existing checks if they are not to be set anyway
        for role in current_roles:
            if not role in new_roles:
                interpreter.uncheck(ctrl % role)
        # Make missing selections
        for role in new_roles:
            # No need to check what was already checked
            if not role in current_roles:
                interpreter.check(ctrl % role)

    def submit(self):
        interpreter.clickAndWait("form.button.Modify")
