from funittest import physical
from funittest import interpreter
from funittest import models
from funittest.seleniumrc import DEFAULTTIMEOUT

class Workflow(models.Physical):
    """
    """
    def get_state(self):        
        attribute = None
        element_locator = "//dl[@id='statusMenu']/dt[@class='actionMenuHeader']/a/span"
        attribute_locator = element_locator + "/@class"
        if interpreter.is_element_present(element_locator):
            state = interpreter.get_attribute(attribute_locator)
            attribute = state[len('state-'):] # Class can be for example "state-visible" or "state-published"
        return attribute            

    def change_state(self, transition):
        element_locator = "workflow-transition-%s" % transition
        interpreter.click(element_locator)
        interpreter.wait_for_condition("selenium.browserbot.getCurrentWindow().jQuery.active == 0", DEFAULTTIMEOUT)

    def access_review_list(self, content):
        physical.plone.navigation.open('/full_review_list')
    
    def browse_review_list(self, content):
        while not interpreter.is_element_present("link=%s" % content['title']) and interpreter.is_element_present("//span[@class='next']//a"):
            interpreter.clickAndWait("//span[@class='next']//a")
    
    def access_content_to_review(self, content):
        element_locator = content['title']
        interpreter.clickAndWait("link=%s" % content['title'])
