# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import logical
from funittest import Testable

class Sharing(Testable):
        
    def having_local_roles(self, localroles):
        """
        Assumes to be in the context of an object, where local roles should
        be applied.
        
        Pass in a list of dictionaries:
        [{'username':'username','type':'user','local_roles':['Role1','Role2',]},
         {'id':'groupid','type':'group','local_roles':['Role1','Role2',]}
        ]
        """
        logical.plone.sharing.access()        
        code = []
        code.append("transaction_manager.begin()")
        code.append("from Products.CMFCore.utils import getToolByName")
        code.append("pm = getToolByName(portal, 'portal_membership')")
        set_localroles = "pm.setLocalRoles(obj=context,member_ids=('%s'),member_role=('%s'))"
        for localrole in localroles:
            command = set_localroles % (localrole['id'], localrole['local_roles'])
            code.append(command)
        code.append("transaction_manager.commit()")
        logical.clouseau.session.process_code_in_context('\n'.join(code))
        for localrole in localroles:
            logical.plone.sharing.access()
            if localrole['type']=='user':
                logical.plone.sharing.add_roles_for_user(localrole['id'], localrole['local_roles'])
            elif localrole['type']=='group':
                logical.plone.sharing.add_roles_for_group(localrole['id'], localrole['local_roles'])

