# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import logical
from funittest import dataprovider
from funittest import Testable
from funittest import interpreter

class User(Testable):

    def existing_users(self, users):        
        """
        Pass in a list of user dictionaries like this:
        
        [user1,
         user2,
        ]
        """
        interpreter.annotate("Setup users using Clouseau")
        physical.plone.navigation.open("/")        
        user=dataprovider.plone.user.get('managerreviewer')
        logical.plone.application.change_user(user)                
        code = []
        code.append("transaction_manager.begin()")
        code.append("from Products.CMFCore.utils import getToolByName")
        code.append("selenium = getToolByName(portal, 'portal_selenium')")
        add_user = "selenium.addUser(id='%s',fullname='%s',roles=%s,groups=%s)"
        for user in users:
            command = add_user % (user['username'], user['fullname'], str(user['roles']), str(user['groups']))
            code.append(command)
        code.append("transaction_manager.commit()")
        logical.clouseau.session.process_code('\n'.join(code))
                
