from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class AddContent(models.Scenario):
    """
    Add a content in a context
    
    Preparation:
    
    1. Choose a user
    2. Choose a content
    
    Precondition
    
    The user is in a context where content can be added
    
    Use Case:
    
    1. Add content
    """

    schema = Schema({"content":dataprovider.plone.content,
                     })

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.folder.add(self._content)
        
    def step_2(self):
        logical.plone.content.edit(self._content)
        
    def step_3(self):
        logical.plone.content.save(self._content)

    def scenario(self):
        """
        Add a content in a context
        """
        self.expect_ok(1,2,3)

    def scenario_1a(self):
        """
        The content can not be created in this context
        """
        type_name = self._content['type_name']
        self._content['type_name']='BogusTypeName'
        self.expect_ko(1)
        self._content['type_name']=type_name
        self.expect_ok(1,2,3)
