from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class AddGroup(models.Scenario):
    """
    Add a new group to the site
    
    Precondition
    
    1. Group is not yet registered
    
    Main scenario
    
    1. Access the users and groups control panel
    2. Access the groups tab
    3. Add group
    4. Fill group information
    5. Save group
    """

    schema = Schema({"group":dataprovider.plone.group})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.addgroup.access()

    def step_2(self):
        logical.plone.addgroup.edit(self._group)

    def step_3(self):
        logical.plone.addgroup.submit()

    def scenario(self):
        """
        Add a new group to the site
        """
        self.expect_ok(1,2,3)

