from funittest import dataprovider
from funittest import logical
from funittest import interpreter
from funittest import models
from funittest import Schema

class AddUser(models.Scenario):
    """
    Add a new member to the site
    
    Precondition
    
    1. User is not yet registered
    
    Main scenario
    
    1. Access the user control panel
    2. Add user
    3. Fill user information
    4. Save user
    """

    schema = Schema({"user":dataprovider.plone.user})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.adduser.access(self._user)

    def step_2(self):
        logical.plone.adduser.fill(self._user)

    def step_3(self):
        logical.plone.adduser.submit(self._user)

    def scenario(self):
        """
        Add a new member to the site
        """
        self.expect_ok(1,2,3)

