from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class ChangeState(models.Scenario):
    """
    Change the state of a content
    
    Preparation:
    
    1. Choose a transition
    
    Precondition:
    
    1. A transition can be made for the content in the current context
    
    Use Case:
    
    1. The user change the state using the transition
    """

    schema = Schema({"transition":dataprovider.plone.transition,
                     })

    def step_1(self):
        logical.plone.workflow.change_state(self._transition)

    def scenario(self):
        """
        """
        self.expect_ok(1)

    def scenario_1a(self):
        """
        User wants to do a transition, and doesn't find the right one at
        first, but finally does the transition.
        """
        transition = self._transition
        self._transition={}
        self.expect_ko(1)
        self._transition = transition
        self.expect_ok(1)
