from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class ChangeWorkflowPolicyForFolder(models.Scenario):
    """
    Change the workflow policy for a folder
    
    Preparation:
    
    1. Choose a user
    2. Choose a context
    3. Choose a workflow policy
    
    Precondition:
    
    1. The user is in the context of a content 
    2. The user has the rigth to change the workflow policy
    
    Use Case:
    
    1. The user goes to the workflow policy in the state drop-down
    2. The administrator selects the policy for this folder
    3. The administrator saves the form
    """

    schema = Schema({"workflowpolicy":dataprovider.plone.workflowpolicy,
                     })

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.workflowpolicy.change_workflow_policy(self._workflowpolicy)

    def scenario(self):
        """
        """
        self.expect_ok(1)

