from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class DeleteContent(models.Scenario):
    """
    Delete a content in a context
    
    Preparation:
    
    1. Choose a user
    2. Choose a context
    3. Choose a content
    
    Use Case:
    
    1. Access folder contents
    2. Delete content if it is in the folder contents
    """

    schema = Schema({"content":dataprovider.plone.content,
                     })

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.foldercontents.access()

    def step_2(self):
        if logical.plone.foldercontents.in_folder_contents(self._content):
            logical.plone.foldercontents.delete(self._content)

    def scenario(self):
        self.expect_ok(1,2)
