from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import scenarios
from funittest import Schema

class DeleteUser(models.Scenario):
    """
    Delete a member of the site
    
    Precondition
    
    1. User is registered
    
    Main scenario
    
    1. Search user
    2. Select user
    3. Delete user
    """

    schema = Schema({"user":dataprovider.plone.user})

    def setUp(self):
        pass

    def step_1(self):
        scenarios.plone.searchuser(user=self._user)

    def step_2(self):
        logical.plone.deleteuser.select_user(self._user)

    def step_3(self):
        logical.plone.deleteuser.submit(self._user)

    def scenario(self):
        """
        Add a new member to the site
        """
        self.expect_ok(1,2,3)

