from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class DescendTo(models.Scenario):
    """
    Descend to a context
    
    Preparation:
    
    1. Choose a path
    
    Use Case:
    
    1. Descend to the context
    """

    schema = Schema({"path":dataprovider.plone.path})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.navigation.down(self._content)

    def scenario(self):
        """
        Navigate to a context
        """
        if len(self._path['path']) == 0:
            pass
        else:
            for content in self._path['path']:
                self._content = content
                self.expect_ok(1)
