from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class InstallProduct(models.Scenario):
    """
    Install a product in the Plone site
    
    Precondition
    
    1. Product is not installed
    
    Main scenario
    
    1. Access the Add/Remove Products control panel
    2. Select product
    3. Install
    """

    schema = Schema({"product" : dataprovider.plone.product})

    def step_1(self):
        logical.plone.product.access()

    def step_2(self):
        logical.plone.product.select(self._product)

    def step_3(self):
        logical.plone.product.install(self._product)

    def scenario(self):
        """
        Install a product
        """
        self.expect_ok(1,2,3)

    def scenario_2a(self):
        """Forgetting to select a product to install, or selection in the 
           wrong list.
        """
        self.expect_ko(1,3)
        self.expect_ok(2,3)
        
