from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class Logout(models.Scenario):
    """
    Logout User
    
    Preconditions: 
    
    1. User must be registered
    2. User must be logged in
    
    Scenario:
    
    1. Logout
    2. Go to the Portal home page
    """
    
    schema = Schema({"user" : dataprovider.plone.user})
    
    def setUp(self):
        scenarios.plone.login(user=self._user)

    def step_1(self):
        logical.plone.application.logout()

    def step_2(self):
        logical.plone.navigation.top()

    def scenario(self):
        self.expect_ok(1,2)

