from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class NestContent(models.Scenario):
    """
    The user wants to nest all content on a path one inside the other.
    
    Preparation:
    
    1. Choose a user
    2. Choose a context
    3. Choose a path
    
    Use Case:
    
    1. Add the first item on the path to the context
    2. Add the next item on the path inside the previous content
    3. Go on with step 3 until no more content on path
    """

    schema = Schema({"path":dataprovider.plone.path,
                     })

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.folder.add(self._content)
        
    def step_2(self):
        logical.plone.content.edit(self._content)
        
    def step_3(self):
        logical.plone.content.save(self._content)

    def scenario(self):
        for content in self._path['path']:
            self._content = content
            self.expect_ok(1,2,3)

