from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class NestContentMerge(models.Scenario):
    """
    The user wants to nest all content on a path one inside the other,
    merging with the already existing content.
    
    Preparation:
    
    1. Choose a user
    2. Choose a context
    3. Choose a path
    
    Use Case:
    
    1. Go to the current context
    2. If the first item on the path exists, go down to the item,
       otherwise add it. 
    3. Add the next item on the path inside the previous content,
       but go down to the item if it exists
    4. Go on with step 3 until no more content on path
    """

    schema = Schema({"path":dataprovider.plone.path,
                     })

    def setUp(self):
        pass
        
    def step_1(self):
        scenarios.plone.addcontent(content = self._content)

    def scenario(self):
        for content in self._path['path']:
            # Try accessing the item
            if logical.plone.foldercontents.in_folder_contents(content):
                logical.plone.navigation.down(content)
            else:
                self._content = content
                self.expect_ok(1)


