from funittest import dataprovider
from funittest import scenarios
from funittest import logical
from funittest import models
from funittest import Schema

class PositionContent(models.Scenario):
    """
    Position a content somewhere in the site, following the necessary folders
    in the process. 
    
    Preparation:
    
    1. Choose a user
    2. Choose a context
    3. Choose a path
    3. Choose a content
    
    Use Case:
    
    1. Follow the folders on the path
    2. Create content
    """

    schema = Schema({"user":dataprovider.plone.user,
                     "context":dataprovider.plone.context,
                     "path":dataprovider.plone.path,
                     "content":dataprovider.plone.content
                     })

    def setUp(self):
        scenarios.plone.login(user = self._user)
        scenarios.plone.navigateto(context = self._context)
        logical.plone.tab.access({'id':'folderContents', 'title':'Contents'})
        
    def step_1(self):
        for item in self._path['path']:
            logical.plone.navigation.down(item)

    def step_2(self):
        scenarios.plone.addcontent(content = self._content)

    def scenario(self):
        self.expect_ok(1, 2)
