from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SearchContent(models.Scenario):
    """
    Search a content in the Plone site using the search field and access it
    
    Precondition:

    There is a search field on the Plone site

    The user is assumed to have access to the content.

    Main scenario
    
    1. Access the Plone site
    2. Search for a content
    3. Go through the next pages until the content is found
    4. Access content
    """

    schema = Schema({"content":dataprovider.plone.content,})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.navigation.top()

    def step_2(self):
        logical.plone.search.search_content(self._content)

    def step_3(self):
        logical.plone.search.browse_results(self._content)

    def step_4(self):
        logical.plone.search.access_content(self._content)

    def scenario(self):
        self.expect_ok(1,2,3,4)

    def scenario_3a(self):
        """
        Add content with a common and specific number until the search result
        shows a next in batch mode (We can not know the batch size).
        Make sure that the search still works.
        """
        pass

