from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SearchGroup(models.Scenario):
    """
    Search a group in the Plone site using the User/Group control panel
    
    Main scenario
    
    1. Access the users and groups control panel
    2. Access the groups tab
    3. Search the group
    """

    schema = Schema({"group":dataprovider.plone.group})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.groupsearch.access(self._group)

    def step_2(self):
        logical.plone.groupsearch.fill(self._group)

    def step_3(self):
        logical.plone.groupsearch.search(self._group)

    def scenario(self):
        """
        Search group
        """
        self.expect_ok(1,2,3)

    def scenario_3a(self):
        fullname = self._group['fullname']
        self._group['fullname']="Hokuspokusfidibusdreimalschwarzerkater"
        self.expect_ko(1,2,3)
        self._group['fullname']=fullname
        self.expect_ok(1,2,3)

