from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SearchUser(models.Scenario):
    """
    Search a member in the Plone site using the User/Group control panel
    
    Main scenario
    
    1. Access the user control panel
    2. Fill in the search form
    3. Search the user
    """

    schema = Schema({"user":dataprovider.plone.user})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.usersearch.access(self._user)

    def step_2(self):
        logical.plone.usersearch.fill(self._user)

    def step_3(self):
        logical.plone.usersearch.search(self._user)

    def scenario(self):
        """
        Search User
        """
        self.expect_ok(1,2,3)

    def scenario_3a(self):
        fullname = self._user['fullname']
        self._user['fullname']="Hokuspokusfidibusdreimalschwarzerkater"
        self.expect_ko(1,2,3)
        self._user['fullname']=fullname
        self.expect_ok(1,2,3)

