from funittest import dataprovider
from funittest import physical
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class SetGroupProps(models.Scenario):
    """
    Change group properties
    
    Precondition
    
    1. Group is registered
    2. The current group has the permission to change the properties of groups

    Main scenario
    
    1. Admin logs in
    2. Admin searches the group
    3. Admin accesses the group properties
    4. Admin edits the group properties
    5. Admin saves the group properties
    """

    schema = Schema({"group":dataprovider.plone.group})

    def setUp(self):
        pass

    def step_1(self):
        scenarios.plone.searchgroup(group=self._group)

    def step_2(self):
        logical.plone.groupprops.select_group(self._group)

    def step_3(self):
        logical.plone.groupprops.select_group_details(self._group)

    def step_4(self):
        logical.plone.groupprops.edit(self._group)

    def step_5(self):
        logical.plone.groupprops.submit(self._group)

    def scenario(self):
        self.expect_ok(1,2,3,4,5)

