from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class SetPreferences(models.Scenario):
    """
    User defines the personal preferences
    
    Precondition
    
    1. User is registered
    
    Main scenario
    
    1. User logs in
    2. User goes to the personal settings
    3. User edits the settings
    4. User saves the settings
    """

    schema = Schema({"user":dataprovider.plone.user,
                     "form":dataprovider.plone.form,
                    },
                   )

    def setUp(self):
        scenarios.plone.login(user=self._user)

    def step_1(self):
        logical.plone.preferences.access()

    def step_2(self):
        logical.plone.preferences.edit(self._form)

    def step_3(self):
        logical.plone.preferences.submit()

    def scenario(self):
        self.expect_ok(1,2,3)

    def scenario_2a(self):
        """
        User clicks on logout instead of on preferences
        """
        self.expect_ok(1)
        logical.plone.application.logout()
        self.expect_ko(2)
        logical.plone.application.login(self._user)
        self.expect_ok(1,2,3)
