from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SetSiteSecurity(models.Scenario):
    """
    Set site security settings
    
    Main scenario
    
    1. Go to site security settings
    2. Configure settings
    3. Save
    """

    schema = Schema({"sitesecurity":dataprovider.plone.sitesecurity})

    def precondition(self):
        # Security configlet is needed
        return "Security" in dataprovider.plone.configlet.keys()
 
    def setUp(self):
        pass

    def step_1(self):
        logical.plone.sitesecurity.access()

    def step_2(self):
        logical.plone.sitesecurity.edit(self._sitesecurity)

    def step_3(self):
        logical.plone.sitesecurity.submit()

    def scenario(self):
        """
        Set site security settings
        """
        self.expect_ok(1,2,3)
    
    def scenario_3a(self):
        """
        Setting wrong configuration.
        """
        sitesecurity = self._sitesecurity.copy()
        for key in self._sitesecurity:
            if self._sitesecurity[key]:
                self._sitesecurity[key]=False
            else:
                self._sitesecurity[key]=True
        self.expect_ko(1,2,3)
        self._sitesecurity = sitesecurity
        self.expect_ok(2,3)
