from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SetSiteSettings(models.Scenario):
    """
    Set site settings
    
    Main scenario
    
    1. Go to site settings
    2. Configure
    3. Save
    """

    schema = Schema({"sitesettings":dataprovider.plone.sitesettings})

    def precondition(self):
        # Site configlet is needed
        return "Site" in dataprovider.plone.configlet.keys()

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.sitesettings.access()

    def step_2(self):
        logical.plone.sitesettings.edit(self._sitesettings)

    def step_3(self):
        logical.plone.sitesettings.submit()

    def scenario(self):
        """
        Set site settings
        """
        self.expect_ok(1,2,3)

