from funittest import dataprovider
from funittest import logical
from funittest import models
from funittest import Schema

class SetTypeSetting(models.Scenario):
    """
    Set type setting
    
    Main scenario
    
    1. Go to types settings
    2. Configure type setting
    3. Save
    """

    schema = Schema({"typesetting":dataprovider.plone.typesetting})

    def precondition(self):
        return "Types" in dataprovider.plone.configlet.keys()

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.typesetting.access()

    def step_2(self):
        logical.plone.typesetting.edit(self._typesetting)

    def step_3(self):
        logical.plone.typesetting.submit()
        
    def scenario(self):
        self.expect_ok(1,2,3)

