from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class SetUserProps(models.Scenario):
    """
    Change user properties
    
    Precondition
    
    1. User is registered
    2. The current user has the permission to change the properties of users

    Main scenario
    
    1. Admin logs in
    2. Admin searches the user
    3. Admin edits the properties
    4. Admin saves the properties
    """

    schema = Schema({"user":dataprovider.plone.user,
                     "form":dataprovider.plone.form,
                    },
                   )

    def setUp(self):
        pass

    def step_1(self):
        scenarios.plone.searchuser(user=self._user)

    def step_2(self):
        logical.plone.userprops.select_user_details(self._user)

    def step_3(self):
        logical.plone.userprops.edit(self._user, self._form)
    
    def step_4(self):
        logical.plone.userprops.submit(self._user, self._form)

    def scenario(self):
        self.expect_ok(1,2,3,4)

