from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import Schema
from funittest import models

class UninstallProduct(models.Scenario):
    """
    Uninstall a product in the Plone site
    
    Precondition
    
    1. Product is installed
    
    Main scenario
    
    1. Access the Add/Remove Products control panel
    2. Select product
    3. Uninstall
    """

    schema = Schema({"product":dataprovider.plone.product})

    def step_1(self):
        logical.plone.product.access()

    def step_2(self):
        logical.plone.product.select(self._product)

    def step_3(self):
        logical.plone.product.uninstall(self._product)

    def scenario(self):
        """
        Uninstall a product
        """
        self.expect_ok(1,2,3)

    def scenario_3a(self):
        product_id = self._product['id']
        self._product['id']='bogusid'
        self.expect_ko(1,2,3)
        self._product['id']=product_id
        self.expect_ko(2,3)
        
