# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import physical
from funittest import logical
from funittest import interpreter
from funittest import models

class Path(models.Script):

    def merge_descending_path_top_down(self, descending_path):
        """
        In the current context, merge the path descending from the contex.
        Expecting to be logged in with a user that can add the content.
        If an item on the path exists, it is just followed.
        If an item on the path does not exist, it is created.
        """
        logical.plone.navigation.top()
        logical.plone.tab.access({'id':'folderContents', 'title':'Contents'})
        for item in descending_path['path']:
            # Remember where we are before trying to go down
            location = interpreter.get_location()
            # Try accessing the item
            try:
                logical.plone.navigation.down(item)
            except:
                pass
            # If the location hasn't changed, we need to add the item
            if interpreter.get_location() == location:
                logical.plone.folder.add(item)
                logical.plone.content.edit(item)
                logical.plone.content.save(item)
               
