from funittest import physical
from funittest import models

class Navigation(models.ExpectedStateGenerator):

    def snapshot(self):
        snapshot = physical.plone.breadcrumbs.get()
        self.set_state('breadcrumbs', snapshot)

    def on_up(self):
        breadcrumbs = physical.plone.breadcrumbs.get()
        if len(breadcrumbs) == 0:
            self.set_state('breadcrumbs', [])
        elif len(breadcrumbs) == 1:
            self.set_state('breadcrumbs', breadcrumbs)            
        else:   
            self.set_state('breadcrumbs', breadcrumbs[:-1])

    def on_down(self, item):
        breadcrumbs = physical.plone.breadcrumbs.get()
        self.set_state('breadcrumbs', breadcrumbs + [item['title']])

    def on_top(self):
        breadcrumbs = physical.plone.breadcrumbs.get()
        if len(breadcrumbs) == 0:
            self.set_state('breadcrumbs', [])
        else:   
            self.set_state('breadcrumbs', [breadcrumbs[:1][0]])

    def open_path(self, path):
        breadcrumbs = ['You are here: Home']
        for item in path['path']:
            breadcrumbs.append(item['title'])
        self.failUnless(breadcrumbs == physical.plone.breadcrumbs.get())
