from funittest import dataprovider
from funittest import physical
from funittest import logical
from funittest import interpreter
from funittest import scenarios
from funittest import models

class AddableContent(models.ParameterTest):
    """
    Test that all the different content types are addable
    """

    _user = 'admin'
    _path = '/'
    _types = []

    def test(self):
        user = dataprovider.plone.user.get(self._user)
        scenarios.plone.login(user=user)
        physical.plone.navigation.open(self._path)
        types = set(self._types)
        addable = set(logical.plone.folder.addable_type_names())
        if types != addable and not interpreter.is_dry_run():
            raise AssertionError("Expected: %s, found: %s" %(types, addable))
