from funittest import interpreter
from funittest import logical
from funittest import dataprovider
from funittest import scenarios
from funittest import models

class InstalledProducts(models.ParameterTest):
    """
    Test the installed product list
    """

    _user = 'admin'
    _installed = []
    
    def test(self):
        user = dataprovider.plone.user.get(self._user)
        scenarios.plone.login(user=user)
        logical.plone.product.access() 
               
        products = set(self._installed)
        installed = set(logical.plone.product.installed_products())

        if products != installed and not interpreter.is_dry_run():
            raise AssertionError("Expected: %s, found: %s" %(products, installed))
    
