from funittest import logical
from funittest import dataprovider
from funittest import scenarios
from funittest import Schema
from funittest import models

class NestContentMerge(models.ParameterTest):
    """
    """
    _admin = 'admin'
    _user = 'admin'
    _context = 'root'
    _path1 = 'descending_path_1'
    _path2 = 'descending_path_2'
        
    def test(self):
        admin = dataprovider.plone.user.get(self._admin) 
        user = dataprovider.plone.user.get(self._user)
        context = dataprovider.plone.context.get(self._context)
        path1 = dataprovider.plone.path.get(self._path1)
        path2 = dataprovider.plone.path.get(self._path2)

        # First delete any existing path with the admin user
        scenarios.plone.login(user=admin)
        scenarios.plone.navigateto(context=context)
        scenarios.plone.deletecontent.try_scenario(content=path1['path'][0])
        scenarios.plone.deletecontent.try_scenario(content=path2['path'][0])

        # Nest the content of the first path
        scenarios.plone.login(user=user)
        scenarios.plone.navigateto(context=context)
        scenarios.plone.nestcontentmerge(path = path1)

        # Nest the content of the first path, merging with the first path
        scenarios.plone.navigateto(context=context)
        scenarios.plone.nestcontentmerge(path = path2)
