import unittest

from funittest import physical
from funittest import logical
from funittest import dataprovider
from funittest import scenarios
from funittest import interpreter
from funittest import models

class PositionContent(models.ParameterTest):

    _admin = 'admin'
    _user = 'admin'
    _context = 'root'
    _path = 'descending_path_3'
    _content = 'document-1'
    
    def test(self):
        admin = dataprovider.plone.user.get(self._admin) 
        user = dataprovider.plone.user.get(self._user)
        context = dataprovider.plone.context.get(self._context)
        path = dataprovider.plone.path.get(self._path)
        content = dataprovider.plone.content.get(self._content)

        # First delete any existing path with the admin user
        scenarios.plone.login(user=admin)
        scenarios.plone.navigateto(context=context)
        scenarios.plone.deletecontent.try_scenario(content=path['path'][0])
        # Nest the content of the first path with the admin user
        scenarios.plone.navigateto(context=context)
        scenarios.plone.nestcontentmerge(path = path)

        # Drop the content at the end of the path with the user
        scenarios.plone.login(user=user)        
        scenarios.plone.navigateto(context=context)
        scenarios.plone.positioncontent(user = user, 
                                        context = context,
                                        path = path,
                                        content = content)

if __name__ == "__main__":
    unittest.main()

