import time

from funittest import logical
from funittest import dataprovider
from funittest import scenarios
from funittest import Schema
from funittest import models

class Review(models.ParameterTest):
    """
    Review content
    """

    _admin = 'admin'
    _user = 'reviewer'    
    _content = 'newsitem1'
    
    def test(self):
        admin = dataprovider.plone.user.get(self._admin)
        user = dataprovider.plone.user.get(self._user)
        content = dataprovider.plone.content.get(self._content)
        # Make sure the content title is unique
        content['title']= str(time.time())
        
        scenarios.plone.login(user=admin)
        scenarios.plone.addcontent(content=content)
        transition = dataprovider.plone.transition.get("submit")
        scenarios.plone.changestate(transition=transition)

        scenarios.plone.login(user=user)
        scenarios.plone.reviewcontent(content=content)
        transition = dataprovider.plone.transition.get("publish")
        scenarios.plone.changestate(transition=transition)
