from funittest import logical
from funittest import dataprovider
from funittest import interpreter
from funittest import scenarios
from funittest import Schema
from funittest import models
from funittest.log import logger

class Tour(models.Test):
    schema = Schema()
    
    def setUp(self):
        self._user = dataprovider.plone.user.get("admin")
        self._folder = dataprovider.plone.content.get("folder1")
        self._page = dataprovider.plone.content.get("page1")
        self._newsitem = dataprovider.plone.content.get("newsitem1")
        self._event = dataprovider.plone.content.get("event1")
        self._transition = dataprovider.plone.transition.get('publish')
        scenarios.plone.login(user = self._user)
        logical.plone.navigation.top()

    def step_1(self):
        "Add a folder"
        scenarios.plone.addcontent(content = self._folder)

    def step_2(self):
        """Publish the folder"""
        scenarios.plone.changestate(transition = self._transition)

    def step_3(self):
        "Add a page"
        scenarios.plone.addcontent(content = self._page)

    def step_4(self):
        """Publish the page"""
        scenarios.plone.changestate(transition = self._transition)

    def step_5(self):
        """Go up to the folder"""
        logical.plone.navigation.up()

    def step_6(self):
        "Add a news item"
        scenarios.plone.addcontent(content = self._newsitem)

    def step_7(self):
        """Publish the news item"""
        scenarios.plone.changestate(transition = self._transition)

    def step_8(self):
        """Go up to the folder"""
        logical.plone.navigation.up()

    def step_9(self):
        "Add an event"
        scenarios.plone.addcontent(content = self._event)

    def step_10(self):
        """Publish the event"""
        scenarios.plone.changestate(transition = self._transition)

    def test(self):
        self.expect_ok(1,2,3,4,5,6,7,8,9,10)
