import time
from funittest import logical
from funittest import dataprovider
from funittest import scenarios
from funittest import Schema
from funittest import models

class Workflow(models.ParameterTest):
    """
    Test workflow
    """

    _admin = 'admin'
    _user = 'admin'
    _context = 'root'
    _path = 'descending_path_3'
    _content = 'document-1'
    _pretransitions = ['submit']
    _transitions = ['publish']
    
    def test(self):
        admin = dataprovider.plone.user.get(self._admin) 
        user = dataprovider.plone.user.get(self._user)
        context = dataprovider.plone.context.get(self._context)
        path = dataprovider.plone.path.get(self._path)
        content = dataprovider.plone.content.get(self._content)

        # Make sure the content title is unique
        content['title']= str(time.time()).replace('.', '')

        # First delete any existing path with the admin user
        scenarios.plone.login(user=admin)
        scenarios.plone.navigateto(context=context)
        scenarios.plone.deletecontent.try_scenario(content=path['path'][0])
        # Nest the content of the first path with the admin user
        scenarios.plone.navigateto(context=context)
        scenarios.plone.nestcontentmerge(path = path)
        # Drop the content at the end of the path with the admin user
        scenarios.plone.navigateto(context=context)
        scenarios.plone.positioncontent(user = user, 
                                        context = context,
                                        path = path,
                                        content = content)
        # Do the pre transitions                                
        for transition in self._pretransitions:
            transition = dataprovider.plone.transition.get(transition)
            scenarios.plone.changestate(transition=transition)

        # Login as the user
        scenarios.plone.login(user=user)        
        # Search for the content
        scenarios.plone.searchcontent(content = content)                
        # Do the transitions as the user                     
        for transition in self._transitions:
            transition = dataprovider.plone.transition.get(transition)
            scenarios.plone.changestate(transition=transition)
        
        