from funittest import physical
from funittest import logical
from funittest import interpreter
from funittest import models
from funittest import verify

class Configuration(models.Logical):

    @verify
    def configure_default_language(self, language):
        logical.plone.configlet.access({"id":"Language"})
        physical.plonelanguagetool.configlet.configure_default_language(language)

    @verify
    def configure_supported_languages(self, languages):
        interpreter.annotate("Change supported languages to: %s" % ','.join(languages))
        logical.plone.configlet.access({"id":"Language"})
        physical.plonelanguagetool.configlet.configure_supported_languages(languages)

