from funittest import physical
from funittest import interpreter
from funittest import models

class Configlet(models.Physical):

    def configure_default_language(self, language):
        default_language = interpreter.get_selected_value("defaultLanguage")
        if default_language != 'en':
            interpreter.select("defaultLanguage","value=%s" % 'en')
            interpreter.clickAndWait("//input[@value='Save']")

    def configure_supported_languages(self, languages):
        currently_checked=physical.plone.utils.getAllSelectedCheckboxFieldsById("supportedLanguages:list")
        currently_checked=currently_checked.values()
        # First remove all existing checks if they are not to be set anyway
        for check in currently_checked:
            if not check in languages:
                interpreter.uncheck("/input[@value='%s']" % check)
        # Make missing selections                
        for check in languages:
            # No need to check what was already checked
            if not check in currently_checked:
                interpreter.check("//input[@value='%s']" % check)
        interpreter.clickAndWait("//input[@value='Save']")
