# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from funittest import logical
from funittest import dataprovider
from funittest import Testable
from funittest import interpreter

class Configuration(Testable):

    def has_configuration(self, configuration):        
        """
        Pass in a dictionary like this :
        {'defaultLanguage':'en',
         'supportedLanguages':['de','en','fr','es'],
         'setUseCombinedLanguageCodes':0,
         'displayFlags':1,
         'setPathN':1,
         'setCookieN':1,
         'setRequestN':1,
         'setForcelanguageUrls':1,
         'setAllowContentLanguageFallback':0,
         'startNeutral':1,}
        """
        interpreter.annotate("Setup language settings")
        physical.plone.navigation.open("")        
        user=dataprovider.plone.user.get('managerreviewer')        
        logical.plone.application.change_user(user)                
        code = []
        code.append("transaction_manager.begin()")
        code.append("from Products.CMFCore.utils import getToolByName")
        code.append("ltool = getToolByName(portal, 'portal_languages')")        
        if configuration.has_key('startNeutral'):        
            code.append("ltool.manage_setLanguageSettings('%(defaultLanguage)s',%(supportedLanguages)s,setCookieN=%(setCookieN)s, setRequestN=%(setRequestN)s,setPathN=%(setPathN)s, setForcelanguageUrls=%(setForcelanguageUrls)s,setAllowContentLanguageFallback=%(setAllowContentLanguageFallback)s,setUseCombinedLanguageCodes=%(setUseCombinedLanguageCodes)s,displayFlags=%(displayFlags)s, startNeutral=%(startNeutral)s)" % configuration)        
        else:
            # Old versions of PloneLanguageTool don't have the startNeutral parameter
            code.append("ltool.manage_setLanguageSettings('%(defaultLanguage)s',%(supportedLanguages)s,setCookieN=%(setCookieN)s, setRequestN=%(setRequestN)s,setPathN=%(setPathN)s, setForcelanguageUrls=%(setForcelanguageUrls)s,setAllowContentLanguageFallback=%(setAllowContentLanguageFallback)s,setUseCombinedLanguageCodes=%(setUseCombinedLanguageCodes)s,displayFlags=%(displayFlags)s" % configuration)               
        code.append("transaction_manager.commit()")
        logical.clouseau.session.process_code('\n'.join(code))
                
