# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import unittest
from funittest import logical
from funittest import dataprovider
from funittest import interpreter
from funittest import models

class TestConfiguration(models.Test):

    def test_01_change_default_language(self):
        "Change the default language"
        user=dataprovider.plone.user.get('managerreviewer')
        physical.plone.navigation.open("")
        logical.plone.application.change_user(user)
        logical.plonelanguagetool.configuration.configure_default_language('en')

    def test_02_change_supported_languages(self):
        "Change the supported languages"
        user=dataprovider.plone.user.get('managerreviewer')
        physical.plone.navigation.open("")
        logical.plone.application.change_user(user)
        logical.plonelanguagetool.configuration.configure_supported_languages( ('en', 'fr', 'es', 'de') )       
        
    def test_03_change_configuration(self): 
        configuration = {'defaultLanguage':'fr',
         'supportedLanguages':['de','en','fr','es'],
         'setUseCombinedLanguageCodes':0,
         'displayFlags':1,
         'setPathN':1,
         'setCookieN':1,
         'setRequestN':1,
         'setForcelanguageUrls':1,
         'setAllowContentLanguageFallback':0,
         'startNeutral':1,}        
        precondition.plonelanguagetool.configuration.has_configuration(configuration)
        
if __name__ == "__main__":
    unittest.main()

