from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class EditContent(models.Scenario):
    """
    It should be possible to edit the content

    Use Case:

    1. Descend the path to the content
    2. Access the Edit tab
    3. Edit the content
    4. Save the content
    """

    schema = Schema({"path":dataprovider.plone.path})

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.navigation.open_path(self._path)

    def step_2(self):
        if logical.plone.content.is_locked():
            logical.plone.content.unlock(self._content)
        logical.plone.tab.access({'id':'edit', 'title':'Edit'})

    def step_3(self):
        logical.plone.content.edit(self._content)

    def step_4(self):
        logical.plone.content.save(self._content)

    def scenario(self):
        self.expect_ok(1)
        self._content = self._path['path'][-1]
        self.expect_ok(2,3,4)
