from funittest import dataprovider
from funittest import logical
from funittest import scenarios
from funittest import models
from funittest import Schema

class SearchResultsFound(models.Scenario):
    """
    A user does a search to confirm that there are search results.

    Use Case:

    1. Search
    2. The search results must not be empty
    """

    schema = Schema({"search":dataprovider.plone.search,
                     })

    def setUp(self):
        pass

    def step_1(self):
        logical.plone.search.search_text(self._search)

    def step_2(self):
        results = logical.plone.search.results_number()
        self.failUnless(results > 0)

    def scenario(self):
        self.expect_ok(1,2)
