from funittest import dataprovider
from funittest import scenarios
from funittest import logical
from funittest import Schema
from funittest.models import PolicyTest

class OneStateWorkflow(PolicyTest):
    """
    Test different scenarios on a document that is configured to the 
    single state workflow.
    """

    fix = Schema({"typesetting":dataprovider.plone.typesetting,
                  "path":dataprovider.plone.path,
                 })

    vary = Schema({"user":dataprovider.plone.user})

    def step_1(self):
        admin = dataprovider.plone.user.get("admin")
        scenarios.plone.login(user=admin)
        self.fix['typesetting'].establish(self._typesetting)

    def step_2(self):
        admin = dataprovider.plone.user.get("admin")
        scenarios.plone.login(user=admin)
        # Here we need the path as a list
        self.fix['path'].establish(self._path)
        # In the test, we need the path as a dictionary
        self._path = self.fix['path'].get(self._path[0])

    def step_3(self):
        # Change workflow state
        # 4. Content is in a workflow state
        pass

    def step_4(self):
        # Change local roles
        # 5. Local roles on content
        #    => owner is owner on document
        #    content.manage_setLocalRoles('contributor', ('Contributor', ))
        pass

    def step_5(self):
        # 6. Login user
        #    => "anon", "contributor", ...
        if self._user['id'] == 'anon':
            scenarios.plone.logout(user=self._user)
        else:
            scenarios.plone.login(user=self._user)

    def step_6(self):
        # Run the scenario given the path that is valid for all configurations
        self.scenario(path=self._path)

    def test(self):
        if self._typesetting_changed:
            self.step_1()
            self._typesetting_changed=False
        if self._path_changed:
            self.step_2()
            self._path_changed = False
        # step_3 workflow state
        # step_4 local roles
        self.step_5()
        #if self._user_changed:
        #    self.step_5()
        #    self._user_changed = False
        #else:
        #    # At least go back to top
        logical.plone.navigation.top()
        self.step_6()
