# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import unittest
from funittest import physical
from funittest import models
from funittest import interpreter

class TestBuiltInWidgets(models.Test):
    
    def setUp(self):    
        TestCase.setUp(self)
        physical.plone.navigation.open('')
        precondition.widgetplayground.widgetplayground.edit_builtinwidgets()
                                                                     
    def test_1_getForms(self):
        """Gets all forms and their widgets on the current page"""
        forms = physical.plone.forms.getForms()
        form_names = forms.getFormNames()
        self.failUnless("edit_form" in form_names)
        for form_name in form_names:
            if form_name:
                form = forms.getForm(form_name)
                form_name = form.getName()
                field_ids = form.getFieldIds()
                for field_id in field_ids:
                    widget_name= form.getWidgetName(field_id)
                    widget = form.getWidget(field_id)
                
    def test_2_fillForm(self):
        """Fills all form widgets on the current page"""        
        forms = physical.plone.forms.getForms()
        form = forms.getForm('edit_form')
        values = []
        values.append( {'id':'title', 
                        'value':'Test Title'} )
        values.append( {'id':'stringwidget',
                        'value':'String Widget Test'} )
        values.append( {'id':'textareawidget',
                        'value':'TextArea Widget Test'} )
        values.append( {'id':'richwidget',
                        'value':'Rich Widget Test'} )
        values.append( {'id':'integerwidget',
                        'value':'42'} )
        values.append( {'id':'booleanwidget',
                        'value':'on'} ) # or off
        values.append( {'id':'lineswidget',
                        'value':['line1', 'line2']} )
        values.append( {'id':'selectionwidget-dropdown',
                        'value':'Volvo'} )
        values.append( {'id':'selectionwidget-radio',
                        'value':'Volvo'} )
        values.append( {'id':'multiselectionwidget',
                        'value':['Volvo','BMW']} )
        values.append( {'id':'multiselectionwidget-checkbox',
                        'value':['Volvo','BMW']} )
        values.append( {'id':'datewidget',
                        'value':{'year':2006,
                                 'month':2,
                                 'day':1,            
                                 'hour':12,
                                 'minute':30}
                       })
        values.append( {'id':'filewidget',
                        'value':'My file',
                       })
        values.append( {'id':'inandoutwidget',
                        'value':['Volvo','BMW'],
                       })
        values.append( {'id':'picklistwidget',
                        'value':['Volvo','BMW'],
                       })
        form.fillForm(values)
                
if __name__ == "__main__":
    unittest.main()

