import os

from funittest import dataprovider
from funittest import interpreter
from funittest import load_product_version
import funittest.preset.plone305

def login():
    return funittest.preset.plone305.login()

def version():
    load_product_version("plone", "3.0.5")
    load_product_version("plonepolicy")

def preset():
    # Presets
    dataprovider.plone.content.current = ['news', 'events']
    dataprovider.plone.transition.current = ['publish', 'reject', 'retract', 'submit']
    dataprovider.plone.sitesettings.current = 'Plone default settings, but visible ids'
    dataprovider.plone.sitesecurity.current = 'Self registration with password choice'
    #dataprovider.plone.security.current = 'No self registration'
    dataprovider.plone.user.current = ['admin', 'manager', 'member', 'managerreviewer', 'reviewer']
    dataprovider.plone.context.current = ['/', '/events', '/news', '/Members']
    dataprovider.plone.path.current = ['descending_path_1', 'descending_path_2']

    products = ["AttachmentField",
                "PloneExFile",
                "CMFContentPanels",
                "SimpleForum",
                "PloneGlossary",
                "PlonePopoll",
                "PloneMaintenance",
                "PloneGazette",
                "SimpleAlias",
                "FileSystemStorage",
                "ArcheCSV",
                "CMFPlacefulWorkflow",
                "Clouseau",
                "PloneChat",
                "PloneSelenium",
                "ATColorPickerWidget",
                "ATFlashMovie",
                "PloneFormGen",
                "Ploneboard",
                "plone.app.iterate",
                "PloneArticle", # Must be last to be installed
                ]               #, otherwise kupu complains

    for product in products:
        if product not in dataprovider.plone.product.keys():
            dataprovider.plone.product.provide({'id':product, 
                                                   'name':product})
    dataprovider.plone.product.current = products
    
    content_types = ["Alias",
                     "PloneArticle",
                     "PloneChat",
                     "ContentPanels",
                     "SimpleForum",
                     "SimpleForumFolder",
                     "PloneGlossary",
                     "PloneArticleMultiPage",
                     "FormFolder",
                     "Ploneboard"
                     ]
    for content_type in content_types:
        if not content_type.lower()+'1' in dataprovider.plone.content:
            dataprovider.plone.content.provide({'id':content_type.lower()+'1',
                                               'title':content_type+'1',
                                               'type_name':content_type,
                                              })

    if not "ploneexfile1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"ploneexfile1",
                                           'title':"My PloneExFile",
                                           'type_name':"PloneExFile",
                                           'file_file':"/Users/maik/Projects/funittest/README.txt"
                                          })

    if not "ploneexfile1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"memberexporter1",
                                           'title':"Member exporter 1",
                                           'type_name':"Member+Exporter",
                                          })

    if not "memberimporter1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"memberimporter1",
                                           'title':"Member importer 1",
                                           'type_name':"Member+Importer",
                                          })

    if not "contentimporter1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"contentimporter1",
                                           'title':"Content importer 1",
                                           'type_name':"Content+Importer",
                                          })

    if not "referencemaker1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"referencemaker1",
                                           'title':"Reference Maker 1",
                                           'type_name':"Reference+maker",
                                          })

    if not "plonepopoll1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"plonepopoll1",
                                           'title':"PlonePopoll 1",
                                           'question':'1+1=?',
                                           'choices':'1\n2\n3',
                                           'type_name':"PlonePopoll",
                                          })

    if not "subscriber1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"subscriber1",
                                           'title':"Subscriber 1",
                                           'type_name':"Subscriber",
                                          })

    if not "newslettertheme1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"newslettertheme1",
                                           'title':"Newsletter Theme 1",
                                           'type_name':"NewsletterTheme",
                                          })

    if not "flashmovie1" in dataprovider.plone.content:
        dataprovider.plone.content.provide({'id':"flashmovie1",
                                           'title':"FlashMovie 1",
                                           'type_name':"FlashMovie",
                                          })

    dataproviders = []
    for dp in dataprovider.plone.get_models():
        dataproviders.append(dp)
    return dataproviders

if __name__ == '__main__':
    preset()
