import os

from funittest import dataprovider
from funittest import interpreter
from funittest import load_product_version
import funittest.preset.plone25

def login():
    return funittest.preset.plone25.login()

def version():
    load_product_version("plone", "2.1.4")
    load_product_version("plonepolicy")

def preset():
    # Presets
    dataprovider.plone.content.current = ['news', 'events']
    dataprovider.plone.transition.current = ['publish', 'reject', 'retract', 'submit']
    dataprovider.plone.portalsettings.current = 'Self registration with password choice and visible ids'
    #dataprovider.plone.security.current = 'No self registration'
    dataprovider.plone.user.current = ['admin', 'manager', 'member', 'managerreviewer', 'reviewer']
    dataprovider.plone.context.current = ['/', '/events', '/news', '/Members']
    dataprovider.plone.product.current = ['Archetypes',
                                             'ATContentTypes',
                                             'ATReferenceBrowserWidget',
                                             'ResourceRegistries',
                                             'MimetypesRegistry',
                                             'PortalTransforms',
                                             'kupu',]
                                             
    dataprovider.plone.path.current = ['descending_path_1', 'descending_path_2']
    
    # News Item type name has changed, but we do not want to duplicate
    # the data, so we just set what we expect
    for key in dataprovider.plone.content.keys():
        value = dataprovider.plone.content.get(key)
        if value['type_name'] == "News+Item":
            value['type_name']="News Item"
            dataprovider.plone.content.set(key,value)
    
    # We want to have site security and site settings first before establishing
    # other presets.
    dataproviders = [dataprovider.plone.portalsettings,]
    for dp in dataprovider.plone.get_models():
        # We exclude product and the models we already added
        if dp.__module__ != dataprovider.plone.product.__module__ and not dp.__module__ == dataprovider.plone.portalsettings.__module__:
            dataproviders.append(dp)
    # Return the dataproviders that should be established if nothing more
    # specific is demanded on the command line
    return dataproviders

if __name__ == '__main__':
    preset()
