import os

from funittest import dataprovider
from funittest import scenarios
from funittest import interpreter
from funittest import logger
from funittest import load_product_version

def login():
    admin = dataprovider.plone.user.get("admin")
    logger.login_as_administrator(admin)
    try:
        scenarios.plone.login(user=admin)
    except:
        logger.login_as_administrator_failed(admin)

def version():
    load_product_version("plone", "3.2.0")
    load_product_version("plonepolicy")

def preset():
    
    # Change this to the password for the admin user
    dataprovider.plone.user.update("admin", {'id':'admin','password':'admin'})
    
    # Presets
    dataprovider.plone.content.current = ['news', 'events']
    dataprovider.plone.transition.current = ['publish', 'reject', 'retract', 'submit']
    dataprovider.plone.sitesecurity.current = 'Self registration with password choice'
    dataprovider.plone.sitesecurity.establish_current = True
    dataprovider.plone.sitesettings.current = 'Plone default settings, but visible ids'
    dataprovider.plone.sitesettings.establish_current = True
    #dataprovider.plone.security.current = 'No self registration'
    dataprovider.plone.user.current = ['anon', 'admin', 'contributor', 'editor', 'reader', 'manager', 'member', 'managerreviewer', 'reviewer']
    dataprovider.plone.user.establish_current = True
    dataprovider.plone.context.current = ['/', '/events', '/news', '/Members']
    dataprovider.plone.product.current = []
    dataprovider.plone.path.current = ['news', 'events', 'users']
    # We want to have site security and site settings first before establishing
    # other presets.
    dataproviders = [dataprovider.plone.sitesecurity,
                     dataprovider.plone.sitesettings]
    for dp in dataprovider.plone.get_models():
        # We exclude product and the models we already added
        if dp.__module__ == dataprovider.plone.product.__module__:
            pass
        elif dp.__module__ == dataprovider.plone.sitesecurity.__module__:
            pass
        elif dp.__module__ == dataprovider.plone.sitesettings.__module__:
            pass
        else:
            dataproviders.append(dp)
    
    dataprovider.plonepolicy.onestateworkflow.current = ["documentfolder",]
    dataprovider.plonepolicy.searchresultsfound.current = ["searches",]
    
    # Return the dataproviders that should be established if nothing more
    # specific is demanded on the command line
    return dataproviders

if __name__ == '__main__':
    preset()
